/** Copyright (C) 2017 by Bundesanstalt für Gewässerkunde
 * Software engineering by
 *  Björnsen Beratende Ingenieure GmbH
 *  Dr. Schumacher Ingenieurbüro für Wasser und Umwelt
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */
package org.dive4elements.river.client.client.ui.sinfo;

import java.util.List;

import org.dive4elements.river.client.client.FLYSConstants;
import org.dive4elements.river.client.client.ui.StringArrayParseHelper;
import org.dive4elements.river.client.client.ui.uinfo.ValidationBehaviourSingleMultiInputItem;

import com.smartgwt.client.widgets.form.fields.TextItem;

/**
 * @author Domenico Nardi Tironi
 *
 */
public class MultiBehaviour extends ValidationBehaviourSingleMultiInputItem {

    public MultiBehaviour(final List<String> validInputs, final String errorForItemMsg, final FLYSConstants MSG) {
        super(validInputs, errorForItemMsg, MSG);
    }

    public MultiBehaviour(final FLYSConstants msg) {
        super(msg);
    }

    @Override
    public void appendValue(final TextItem inputItem, final String value) {
        // APPEND = ADD to existing -> MULTI YEAR
        final String oldYears = inputItem.getValueAsString();
        if (oldYears != null && !oldYears.isEmpty())
            inputItem.setValue(oldYears.trim() + " " + value);
        else
            inputItem.setValue(value);

    }

    @Override
    public List<String> validate(final List<String> errors, final String inputValueString) {
        if (inputValueString != null) {
            final String[] sValues = StringArrayParseHelper.getArrayFromRawString(inputValueString);
            for (final String value : sValues) {
                errors.addAll(this.validateSingleInput(value));
            }
        }
        return errors;
    }

}
